<?php
/*
Plugin Name: Link Rel
Plugin URI: http://boxofchocolates.ca/projects/wp-linkrel
Description: Displays link relationships for the previous and next posts in the head of the document.
Version: 0.1
Author: Derek Featherstone
Author URI: http://boxofchocolates.ca
*/


function linkrel($post_ID)
{
	
		rel_next_post();
		rel_previous_post();

	return $post_ID;

}

function rel_next_post($format='%', $next='', $title='yes', $in_same_cat=
'no', $limitnext=1, $excluded_categories='') {
    global $tableposts, $posts_per_page, $post, $wpdb, $single;
    if(1 == $posts_per_page || 1 == $single) {

        $current_post_date = $post->post_date;
        $current_category = $post->post_category;

        $sqlcat = '';
        if ($in_same_cat != 'no') {
            $sqlcat = " AND post_category='$current_category' ";
        }

        $sql_exclude_cats = '';
        if (!empty($excluded_categories)) {
            $blah = explode('and', $excluded_categories);
            foreach($blah as $category) {
                $category = intval($category);
                $sql_exclude_cats .= " AND post_category != $category";
            }
        }

        $now = current_time('mysql');

        $limitnext--;

        $relnextpost = @$wpdb->get_row("SELECT ID,post_title FROM $tableposts WHERE post_date > '$current_post_date' AND post_date < '$now' AND post_status = 'publish' $sqlcat $sql_exclude_cats AND ID != $post->ID ORDER BY post_date ASC LIMIT $limitnext,1");
        if ($relnextpost) {
            $string = '<link rel="next" href="'.get_permalink($relnextpost->ID).'" title="'.$next;
            if ($title=='yes') {
                $string .= wptexturize(strip_tags(stripslashes($relnextpost->post_title)));
            }
            $string .= '" />';
            $format = str_replace('%', $string, $format);
            echo $format;
        }
	}
}


function rel_previous_post($format='%', $previous='', $title='yes', $in_same_cat='no', $limitprev=1, $excluded_categories='') {
    global $tableposts, $id, $post, $wpdb;
    global $p, $posts, $posts_per_page, $s, $single;
    global $querystring_start, $querystring_equal, $querystring_separator;

    if(($p) || ($posts_per_page == 1) || 1 == $single) {

        $current_post_date = $post->post_date;
        $current_category = $post->post_category;

        $sqlcat = '';
        if ($in_same_cat != 'no') {
            $sqlcat = " AND post_category = '$current_category' ";
        }

        $sql_exclude_cats = '';
        if (!empty($excluded_categories)) {
            $blah = explode('and', $excluded_categories);
            foreach($blah as $category) {
                $category = intval($category);
                $sql_exclude_cats .= " AND post_category != $category";
            }
        }

        $limitprev--;
        $rellastpost = @$wpdb->get_row("SELECT ID, post_title FROM $tableposts WHERE post_date < '$current_post_date' AND post_status = 'publish' $sqlcat $sql_exclude_cats ORDER BY post_date DESC LIMIT $limitprev, 1");
        if ($rellastpost) {
            $string = '<link rel="prev" href="'.get_permalink($rellastpost->ID).'" title="'.$previous;
            if ($title == 'yes') {
                $string .= wptexturize(strip_tags(stripslashes($rellastpost->post_title)));
            }
            $string .= '" />';
            $format = str_replace('%', $string, $format);
            echo $format;
		}
	}
}




add_action("wp_head", "linkrel");


?>